#include "ofHttpParser.h"


ofHttpParser::ofHttpParser(){
	doc = new TiXmlDocument;
}
		
//------------------------------------------------------------------
string ofHttpParser::tidyHtml(string input){
	
	TidyBuffer 	output = {0};
	TidyBuffer 	errbuf = {0};
	Bool 		ok;
	int 		rc;
	TidyDoc 	tdoc = tidyCreate();                     // Initialize "document"
	
	ok = tidyOptSetBool( tdoc, TidyXhtmlOut, yes );  // Convert to XHTML
	if ( ok )
	rc = tidySetErrorBuffer( tdoc, &errbuf );      // Capture diagnostics
	if ( rc >= 0 )
	rc = tidyParseString( tdoc, input.c_str() );           // Parse the input
	if ( rc >= 0 )
	rc = tidyCleanAndRepair( tdoc );               // Tidy it up!
	if ( rc >= 0 )
	rc = tidyRunDiagnostics( tdoc );               // Kvetch
	if ( rc > 1 )                                    // If error, force output.
	rc = ( tidyOptSetBool(tdoc, TidyForceOutput, yes) ? rc : -1 );
	if ( rc >= 0 );
	rc = tidySaveBuffer( tdoc, &output );          // Pretty Print
	/*
	some error reporting
	if ( rc >= 0 )
	{
		if ( rc > 0 )
		printf( "\nDiagnostics:\n\n%s", errbuf.bp );
	}
	else
	printf( "A severe error (%d) occurred.\n", rc );
	*/
	string temp((char *)(output.bp));
	
	tidyBufFree( &output );
	tidyBufFree( &errbuf );
	tidyRelease( tdoc );
	
	return temp;
}


//------------------------------------------------------------------
void ofHttpParser::parseHtml (string input){
			
	doc->Parse ( input.c_str() );
	
	
	
	
	htmlCopy = input;
	
	/*
	this counts # of a hrefs....
	char * div_count = "count(//a[@href])";
	int nDivs = TinyXPath::i_xpath_int (doc -> RootElement (), div_count);
	printf("there are %i items in html:body:script \n", nDivs);
	*/
	
	/*
	//this, for example, lists out the images:
	TinyXPath::xpath_processor xp_proc (doc -> RootElement (), "//img[@src]");    // build the list of all element nodes in the tree
   	int nTags = xp_proc . u_compute_xpath_node_set ();            // retrieve number of nodes 
	for (int i = 0; i < nTags; i++){
	printf("\n");
	xp_proc.XNp_get_xpath_node(i)->Print(stdout,0);
	}
	
	//vector of srings - could be useful 
	void blah(vector<string>& strings)
	{
		// do stuff
	}

	int main()
	{
		vector<string> v;
		// v.push_back(some); v.push_back(strings);
		blah(v);
	}
	*/
	
	
	/*
	regex
	char ptn[] = "\\d+\\.?\\d*|\\.\\d+";
	char txt[] = "such as 1, 234, 12.5, .78 etc";

	// compile
	CRegexpT <char> regexp(ptn);

	// find first
	MatchResult result = regexp.Match(txt);

	while(result.IsMatched())
	{
	// print found
	printf("%.*s\n", result.GetEnd() - result.GetStart(), txt + result.GetStart());

	// find next
	result = regexp.Match(txt, result.GetEnd());
	}*/
	
}

